% 
% function sigma = IFT(API,p,T)

% sigma68 = 39 - 0.2571*API;
% sigma100 = 37.5 - 0.2571*API;
% sigmaN = sigma68 - (T-68)*(sigma68-sigma100)/32;
% 
%     if T > 100
%         sigmaOD = sigma100;
%     elseif T < 68
%         sigmaOD = sigma68;
%     else
%         sigmaOD = sigmaN;
%     end
% 
%     x = exp(-8.6306*10^-4*p);
%     sigma = sigmaOD*x;
% end

close all
clear all
clc
subplot(121)
Tv = [68 100]; %1:220;
pv = 0:500:1000;
APIv = 1:55;

hold all
for p = pv
for T = Tv
    for API = APIv
        sigma(API) = IFT(API,p,T);
    end
    if p>0
        plot(APIv, sigma, 'DisplayName', ['@ ',num2str(T),'F,  ',num2str(p),' psi'])
    else
        plot(APIv, sigma, 'DisplayName', ['Dead Oil @ ',num2str(T),'F'])
    end
end
end

grid on
xlabel('Oil Gravity, API')
ylabel('Interfacial Tension, dynes\cm')
title('Interfacial Tension')


%%

subplot(122)
clear all

APIv = [10 20 30 40 50 60];
Tv = 1:220;
p = 0;

hold all
for API = APIv

    for T = Tv
        sigma(T) = IFT(API,p,T);
    end
    plot(Tv, sigma, 'DisplayName', ['API = ',num2str(API)])
end


grid on
xlabel('Temperature, F')
ylabel('Interfacial Tension, dynes\cm')
title('Dead Oil Interfacial Tension')