
clear all
close all
clc

i = 0;
j = 0;

NFRv = logspace(-1, 3, 1000);
lamdaLv = logspace(-4, 0, 1000);


for NFR = NFRv;
    
    i = i+1;
    j = 0;
    
    for lamdaL = lamdaLv

        j = j+1;
        


        L1 = 316*lamdaL^0.302;                         % Flow Indicator
        L2 = 0.0009252*lamdaL^(-2.4684);                % Flow Indicator
        L3 = 0.1*lamdaL^(-1.4516);                     % Flow Indicator
        L4 = 0.5*lamdaL^(-6.738);                      % Flow Indicator

        if((lamdaL < 0.01 && NFR < L1) || (lamdaL >= 0.01 && NFR < L2))
            Flowtype = 1; %'segregated';
        elseif((0.01<=lamdaL && lamdaL<0.4 && L3 < NFR && NFR <= L1)...
                || (lamdaL >= 0.4 && L3 < NFR && NFR <= L4))
            Flowtype = 2; %'intermittent';
        elseif((lamdaL < 0.4 && NFR >= L1) || (lamdaL >= 0.4 && NFR > L4))
            Flowtype = 3; %'distributed';
        elseif(L2 < NFR && NFR < L3)
            Flowtype = 4; %'transition';
        end
        
      
        
        Pattern(i,j) = Flowtype;

    end
end

contourf(lamdaLv, NFRv, Pattern)
set(gca,'Xscale','log','Yscale','log','Ydir','normal');

colormap('Cool')
grid on

ylabel('NRF')
xlabel('lamda L')
title('Flow Map Beggs & Brill')
