%clear all; close all; clc

for T = [77 300]

GASTYPE = 'N2';

pv = 15:7000;

Bg = zeros(1,7000);

for P = pv
    
    
z = zfac4(GASTYPE,T,P);                         % Gas Compressibility
Bg(P) = (14.7/P)*((T+459.67)/519.67)*z;            % cuft/scf


end

plot(pv, Bg(15:7000), 'DisplayName', [GASTYPE, ' @ ',num2str(T),'F'])
hold all


end


grid on
xlabel('Pressure, psi')
ylabel('Gas FVF, cuft/scf')
title('Gas Formation Volume Factor')
