function[] = bitoptions(handles)

PressureLossModel = questdlg('Choose Bit Pressure Drop Model','Model Selection',...
    'Simple','Complex','Simple');
% 
% switch button
%     case 1
%         PressureLossModel = 'Simple';
%     case 2
%         PressureLossModel = 'Complex';
% end

NV = [];
Cd = [];
Pbit = [];

switch PressureLossModel
    case 'Complex'
        prompt = {'Bit Size, in:','Discharge Coefficient','Nozzle 1, (x/32")',...
            'Nozzle 2, (x/32")','Nozzle 3, (x/32")','Nozzle 4, (x/32")'...
            'Nozzle 5, (x/32")','Nozzle 6, (x/32")','Nozzle 7, (x/32")'...
            'Nozzle 8, (x/32")','Nozzle 9, (x/32")','Nozzle 10, (x/32")'};
        dlg_title = 'Input';
        num_lines = 1;
        def = {'5','0.98','16','16','16','0','0','0','0','0','0','0','0'};
        answer = inputdlg(prompt,dlg_title,num_lines,def);

        [a, b, c, d, e, f, g, h, i, j, k, l] = answer{:};
        BitSize = str2double(a);
        Cd = str2double(b);
        N1 = str2double(c);
        N2 = str2double(d);
        N3 = str2double(e);
        N4 = str2double(f);
        N5 = str2double(g);
        N6 = str2double(h);
        N7 = str2double(i);
        N8 = str2double(j);
        N9 = str2double(k);
        N10 = str2double(l);
        
        NV = [N1 N2 N3 N4 N5 N6 N7 N8 N9 N10];      
        TFA = sum((NV./32).^2)*pi/4;      
        
        BSstr = ['Bit Selected: ', num2str(BitSize), '", TFA = ', num2str(TFA),' sqin'];
    case 'Simple'
        prompt = {'Bit Size, in:','Bit Pressure Drop, psi'};
        dlg_title = 'Input';
        num_lines = 1;
        def = {'5','50'};
        answer = inputdlg(prompt,dlg_title,num_lines,def);
        [a, b] = answer{:};
        BitSize = str2double(a);
        Pbit = str2double(b);
        BSstr = ['Bit Selected: ', num2str(BitSize), '", Pressure Drop = ', num2str(Pbit),' psi'];
end


set(handles.text205, 'String', BSstr)
set(handles.edit99, 'String', num2str(BitSize))
set(handles.uitable17, 'Data', [Pbit Cd NV])

end
