clear all; close all; clc

i = 0;
VAL = [];


        

for GPM = 500; %[500, 1000, 2000]

    
qL_SC = GPM/42*60*24;   %	Liquid production rate:	2000	  stb/d     500gpm


for corr = 1:8

    switch corr
        case 1
            correlation = 'Poettmann';
        case 2
            correlation = 'PoettmannSIMPLIFIED';
        case 3
            correlation = 'Baxendell';
        case 4
            correlation = 'Brown';
        case 5
            correlation = 'Hagedorn';
        case 6
            correlation = 'Gray';
        case 7
            correlation = 'Dun';
        case 8
            correlation = 'BeggsBrill';
    end

for GLR = [20, 100, 200]
        
i = i + 1;

WC = 0.00;              %	Water cut (WC):	25	  %
Ptop = 100;
API = 20;               %	Oil gravity:	30	  oAPI
yW = 1.05;              %	Water specific gravity:	1.05	  1 for fresh water
GASTYPE = 'N2';
Ttop = 70;              %	Wellhead temperature:	100	  oF
Tbtm = 300;
do = 8.5/12;            %	Tubing ID:	1.66	  in 
di = 3.5/12;
inc = 90;
L = 100;
e_rel = 0.0006;

T = (Ttop+Tbtm)/2;
Pguess = 0;
dev = 1000;



while abs(dev)>0.01;

Pout = Ptop + Pguess;
Pavg = (Ptop + Pout)/2;
[a, b, c] = cor_input_for_test_delete(do, inc, di, qL_SC, GLR, WC, API, yW, T, Pavg, GASTYPE, e_rel, correlation);
dPdZ = a;
dPdZ_el = b/144*L;
dPdZ_f = c/144*L;
dP = dPdZ*L;
dev = Pguess-dP;
Pguess = dP;

end

BHP = Pout;
Pfric = dPdZ_f;
Phydr = dPdZ_el;
Pacce = dP - Phydr - Pfric;

VAL(i,:) = [corr, GPM, GLR, BHP, Pfric, Phydr, Pacce];

end
end
end

header = {'CORR', 'GPM', 'GLR', 'BHP', 'Pfric', 'Phydr', 'Pacce'};
ds = dataset({VAL,header{:}});

Y = [ds.Pfric, ds.Phydr, ds.Pacce];
bar(Y,'stacked')

