clear all
close all
clc

load dunros.mat


Nd = 20;

L1 = interp1(L1(:,1), L1(:,2), Nd);
L2 = interp1(L2(:,1), L2(:,2), Nd);

i = 0;
j = 0;

NLVv = logspace(-2, 4, 1000);
NGVv = logspace(-2, 4, 1000);


for NLV = NLVv;
    
    i = i+1;
    j = 0;
    
    for NGV = NGVv

        j = j+1;
        
        Ls = 50 + 36*NLV;
        Lm = 75 + 84*NLV^0.75;


        if (0 <= NGV && NGV <= L1 + L2*NLV)
            FLOW = 1; %'Bubble Flow';
        elseif (L1+L2*NLV <= NGV && NGV <= Ls)
            FLOW = 2; %'Slug Flow';
        elseif (NGV > Lm)
            FLOW = 3; %'Mist Flow';
        elseif (Ls < NGV && NGV < Lm)
            FLOW = 4; %'Trans';
        end

        Pattern(i,j) = FLOW;
        
    end
    
    
end

%%

contourf(NLVv,NGVv,Pattern)
set(gca,'Xscale','log','Yscale','log','Ydir','normal');

colormap('Cool')
grid on

xlabel('NLV')
ylabel('NGV')
title('Flow Map Dun & Ros, Nd = 200')
