% clear all; close all; clc;
% 
% visL = 1;
% Qve = 0.01:0.01:45;
% Qvm = 0.01:0.01:53.99;
% Qvh = 0.01:0.01:73.99;
% 
% i = 0;
% for Q = Qve
%     i = i + 1;
%     visFeinstein(i) = einstein(Q/100, visL);
% end
% 
% i = 0;
% for Q = Qvm
%     i = i + 1;
%     visFmitchell(i) = mitchell(Q/100, visL);
% end
% 
% i = 0;
% for Q = Qvh
%     i = i + 1;
%     visFhatschek(i) = hatschek(Q/100, visL);
% end
% 
% hold all;
% plot(Qve,visFeinstein)
% plot(Qvh,visFhatschek)
% plot(Qvm,visFmitchell)
% 
% xlabel('Gas Quality, %')
% ylabel('Viscosity, cp')
% title('Viscosity Correlations, Base Fluid Viscosity of 1.00 cp')
% legend('Einstein','Hatschek','Mitchell')
% grid on


clear all; close all; clc;

visL = 1;
Qvm = 54:0.01:94;
Qvh = 54:0.01:74;

i = 0;
for Q = Qvm
    i = i + 1;
    visFmitchell(i) = mitchell(Q/100, visL);
end

i = 0;
for Q = Qvh
    i = i + 1;
    visFhatschek(i) = hatschek(Q/100, visL);
end

hold all;
plot(Qvh,visFhatschek)
plot(Qvm,visFmitchell)

xlabel('Gas Quality, %')
ylabel('Viscosity, cp')
title('Viscosity Correlations, Base Fluid Viscosity of 1.00 cp')
legend('Hatschek','Mitchell')
grid on


% clear all; close all; clc;
% 
% for visL = [0.1 0.25 0.5 1 1.5 2 3];
% Qve = 0.01:0.01:45;
% 
% i = 0;
% for Q = Qve
%     i = i + 1;
%     visFeinstein(i) = einstein(Q/100, visL);
% end
% 
% hold all;
% plot(Qve,visFeinstein,'DisplayName',['Base Fluid Viscosity: ' num2str(visL),' cp'])
% 
% xlabel('Gas Quality, %')
% ylabel('Viscosity, cp')
% title('Foam Viscosity from Einstein')
% grid on
% 
% end
% clear all; close all; clc;
% 
% for visL = [0.1 0.25 0.5 1 1.5 2 3];
% Qvh = 0.01:0.01:99;
% 
% i = 0;
% for Q = Qvh
%     i = i + 1;
%     visFhatschek(i) = hatschek(Q/100, visL);
% end
% 
% semilogy(Qvh,visFhatschek,'DisplayName',['Base Fluid Viscosity: ' num2str(visL),' cp'])
% hold all;
% 
% xlabel('Gas Quality, %')
% ylabel('Viscosity, cp')
% title('Foam Viscosity from Hatschek')
% grid on
% 
% end


% clear all; close all; clc;
% 
% for visL = [0.1 0.25 0.5 1 1.5 2 3];
% Qvm = 0.01:0.01:97;
% 
% i = 0;
% for Q = Qvm
%     i = i + 1;
%     visLmitchell(i) = mitchell(Q/100, visL);
% end
% 
% semilogy(Qvm,visLmitchell,'DisplayName',['Base Fluid Viscosity: ' num2str(visL),' cp'])
% hold all;
% 
% xlabel('Gas Quality, %')
% ylabel('Viscosity, cp')
% title('Foam Viscosity from Mitchell')
% grid on
% 
% end
