clear all;
close all;
clc;

T = 200;
yG = 0.77;
API = 20;
GASTYPE = 'CH4';
yW = 1.05;
yO = 141.5/(131.5+API);

for P = 1:10000;

Bw = bw_mccain(P,T);
pb = 5000; %p_bubble(GOR,yG,T,API);                                         % Bubble Point Pressure, psi
[Rs, Bo] = standing(yG, API, pb, P, T);
z = zfac4(GASTYPE,T,P);                                             % Gas Compressibility
Bg = (14.7/P)*((T+459.67)/519.67)*z;            % cuft/scf


rhoG = 2.7*P*yG/(z*(T+459.67)); %1.79;                 % lbm/cuft
rhoO = (yO*62.4+yG*0.0764*Rs/5.614)/Bo;         % lbm/cuft
rhoW = yW*62.4/Bw;                              % lbm/cuft

k(P) = rhoO; 

end

plot(k)
grid on