function vis = foamrheology(Q,vf,do,di,YP,PV,visL,Correlation)

if di == 0;
    TYPE = 'Pipe';
    dh = do;
else
    TYPE = 'Annular';
    dh = do - di;
end

switch Correlation
    case 'Sanghani'
        [n, K] = sanghani(Q);
        vis_eA = K*((2*n+1)/(3*n))^n*(12*vf/dh)^(n-1);
        vis_eP = K*((3*n+1)/(4*n))^n*(8*vf/dh)^(n-1);
        switch TYPE
            case 'Annular'
                vis = vis_eA;     
            case 'Pipe'
                vis = vis_eP;
        end
    case 'Reidenbach'
        [n, K] = reidenbach(Q);
        vis_eA = K*((2*n+1)/(3*n))^n*(12*vf/dh)^(n-1);
        vis_eP = K*((3*n+1)/(4*n))^n*(8*vf/dh)^(n-1);
        switch TYPE
            case 'Annular'
                vis = vis_eA;
            case 'Pipe'
                vis = vis_eP;
        end  
    case 'Mitchell'
        visF = mitchell(Q, visL);
        vis = visF;
    case 'Hatschek'
        visF = hatschek(Q, visL);
        vis = visF;
    case 'Einstein'
        visF = einstein(Q, visL);
        vis = visF;
    case 'Blauer'
        vis_e = blauer(PV,YP,dh,vf);
        vis = vis_e;
end


end
