clear all; close all; clc;

% 
% Tv = 1:400;
% 
% GASTYPE = 'CH4';
% 
% [Mg, yG] = gasprop(GASTYPE);
% 
% subplot(121)
% 
% for P = [14.7 250 500 1000 1500 3000]
% %P = 2000;
% 
% 
% for T = Tv
%     
%     z = zfac4(GASTYPE,T,P);  
%     rho = 2.7*P*yG/(z*(T+459.67));
%     visGas(T) = gasviscosity(rho, Mg, T);
% 
% end
% 
% plot(Tv, visGas, 'DisplayName', ['@ ',num2str(P),' psi'])
% hold all
% grid on
% 
% end
% 
% xlabel('Temperature, F')
% ylabel('Viscosity, cp')
% title('Gas Viscosity for Methane')
% 
% 
% 
% 
% %clear all; close all; clc;
% 
% subplot(122)
% 
% Pv = 1:6000;
% 
% for T = [77 100 150 200 250 300]
% %P = 2000;
% 
% 
% for P = Pv
%     
%     z = zfac4(GASTYPE,T,P);  
%     rho = 2.7*P*yG/(z*(T+459.67));
%     visGasP(P) = gasviscosity(rho, Mg, T);
% 
% end
% 
% plot(Pv, visGasP, 'DisplayName', ['@ ',num2str(T),' F'])
% hold all
% grid on
% 
% end
% 
% xlabel('Pressure, F')
% ylabel('Viscosity, cp')
% title('Gas Viscosity for Methane')
% 
% 
% 
% 
% figure


clear all;


Tv = 75:400;


for i = 2:8
    
    
    switch i
        case 1
            GASTYPE = 'AIR';
        case 2
            GASTYPE = 'NH3';
        case 3
            GASTYPE = 'CO2';
        case 4
            GASTYPE = 'CH4';
        case 5
            GASTYPE = 'N2';
        case 6
            GASTYPE = 'O2';
        case 7
            GASTYPE = 'C3H8';
        case 8
            GASTYPE = 'SO2';
    end
    
   
    
[Mg, yG] = gasprop(GASTYPE);

P = 200;


for T = Tv
    
    z = zfac4(GASTYPE,T,P);  
    rho = 2.7*P*yG/(z*(T+459.67));
    visGas(T) = gasviscosity(rho, Mg, T);

end

plot(Tv, visGas(75:400) , 'DisplayName', ['Gas: ' ,char(GASTYPE)])
hold all
grid on

drawnow

end

xlabel('Temperature, F')
ylabel('Viscosity, cp')
title('Gas Viscosities @ 200 psi')

