function [HL, ke] = gray_HL(rhon, vm, g, lamdaL, sigmaL, rhoL, rhoG, dh, Rv, k)

sigmaL = 0.00220462*sigmaL;


N1 = rhon^2*vm^4/(g*sigmaL*(rhoL-rhoG));
N2 = g*dh^2*(rhoL-rhoG)/sigmaL;
N3 = 0.0814*(1-0.0554*log(1+730*Rv/(Rv+1)));

f1 = -2.314*(N1*(1+205/N2))^N3;
HL = 1 - (1-lamdaL)*(1-exp(f1));
        

ko = 28.5*sigmaL/(rhon*vm^2);

if Rv >= 0.007
    ke = ko;
else
    ke = k + Rv*(ko-k)/0.007;
end

ke = max(ke, 2.77*10^-5);



end