p_top = 1000;      % Pressure, psia
p_btm = p_top;      % Pressure, psia
T = 622;      % Rankine


qG = 3000;    % scf/day
qO = 1000;    % bbl/day
qW = 300;     % bbl/day
qS = 1;       % ft3/day

yG = 0.7;     % Specific Gravity, air = 1;
yO = 0.85;     % Specific Gravity, water = 1;
yW = 1.05;     % Specific Gravity, water = 1;
yS = 2.65;     % Specific Gravity, water = 1;

L = 5000;

do = 2; %in
g = 32.2;
A = pi()/4*do^2;  %sqin

phi = 20;   %degrees

DH = do/12; %ft

dev = 100;

while abs(dev)>0.001
   
    p_btm = p_btm + 0.8*abs(dev);

Mass = 350.17*(yO+qW/qO*yW)+qG/qO*0.0765*yG;
rho_v_d = 1.4737*10^-5*Mass*qO/(DH);
fF = 4*10^(1.444-2.5*log10(rho_v_d));
fM = 4*fF;

a = (0.0765*yG*qG+350*yO*qO+350*yW*qW+62.4*yS*qS)/(4.07*T*qG);
b = (5.615*qO+5.615*qW+qS)/(4.07*T*qG);
c = 0.00678*T*qG/A;
d = 0.00166*(5.615*qO+5.615*qW+qS)/A;
e = fM/(2*g*DH);
M = c*d*e/(cosd(phi)+d^2*e);
N = c^2*e*cosd(phi)/(cosd(phi)+d^2*e)^2;

LHS = 144*b*(p_btm-p_top)+(1-2*b*M)/2*log(abs(((144*p_btm+M)^2+N)/(((144*p_top+M)^2+N))))...
    - (M+b/c*N-b*M^2)/sqrt(N)*(atan((144*p_btm+M)/sqrt(N))-atan((144*p_top+M)/sqrt(N)));
RHS = a*(cosd(phi)+d^2*e)*L;
dev = LHS-RHS;

end