%%%%%%%%%%%%%%%%%%%%%%%%
% 
% d = 1.66; %	Tubing ID:	1.66	  in
% p = 500; %	Wellhead pressure:	500	  psia
% qL = 2000; %	Liquid production rate:	2000	  stb/d
% GLR = 1000; %	Producing gas-liquid ratio (GLR):	1000	  scf/stb
% WC = 0.25; %	Water cut (WC):	25	  %
% API = 30; %	Oil gravity:	30	  oAPI
% yW = 1.05; %	Water specific gravity:	1.05	  1 for fresh water
% yG = 0.65; %	Gas specific gravity:	0.65	  1 for air
% 
% Bw = 1.2; %Formation volume factor for water:	1.2	  rb/stb
% Tavg = 150; %	Wellhead temperature:	100	  oF
% 
% qG = qL*GLR; %scf/day
% qW = qL*WC; % bbl/day
% qO = qL*(1-WC); %bbl/day
% WOR = qW/qO;%bbl/stb
% GOR = qG/qO; %scf/stb
% 
% rhoAIR = 0.0765;
% yO = 141.5/(API+131.5);
%%%%%%%%%%%%%%%%%%%%%%%%%%

% vsg = 4.09;
% vsl = 2.65;
% vm = vsl+vsg;
%d = 0.249;
%P = 720;
%T = 128;

%e = 0.0006*d;
%g = 32.2;

% rhoL = 56.6;
% rhoG = 2.84;
% visL = 18;
% visG = 0.018;

%fO = qO/(qO+qW);
%fW = qW/(qO+qW);

%rhoL = rhoO*fO + rhoW*fW;
%sigmaL = sigmaO*fO + sigmaW*fW;
%visL = visO*fO + visW*fW;
%sigmaL = 29.96;
% 
% NLV = 1.938*vsl*(rhoL/sigmaL)^(1/4);
% NGV = 1.938*vsg*(rhoL/sigmaL)^(1/4);
% Nd = 120.872*d*(rhoL/sigmaL)^(1/2);
% NL = 0.15726*visL*(1/(rhoL*sigmaL^3))^(1/4);
% 
% A1 = -2.698510E+00;
% A2 = 1.584095E-01;
% A3 = -5.509976E-01;
% A4 = 5.478492E-01;
% A5 = -1.219458E-01;
% CNL = 10^(A1+A2*(log10(NL)+3)+A3*(log10(NL)+3)^2+A4*(log10(NL)+3)^3+A5*(log10(NL)+3)^4);
% 
% temp1 = (NLV/NGV^0.575)*(P/14.7)^0.10*(CNL/Nd);
% B1 = -1.030658E-01;
% B2 = 6.177740E-01;
% B3 = -6.329460E-01;
% B4 = 2.959800E-01;
% B5 = -4.010000E-02;
% HL_phi = B1+B2*(log10(temp1)+6)+B3*(log10(temp1)+6)^2+B4*(log10(temp1)+6)^3+B5*(log10(temp1)+6)^4;
% 
% temp2 = NGV*NL^0.38/Nd^2.14;
% if temp2<0.012;
%    temp2 = 0.012;
% end
% C1 = 9.116257E-01;
% C2 = -4.821756E+00;
% C3 = 1.232250E+03;
% C4 = -2.225358E+04;
% C5 = 1.161743E+05;
% phi = C1+C2*temp2+C3*temp2^2+C4*temp2^3+C5*temp2^4;
% HL = HL_phi*phi;


rhoL = 50;
rhoG = 2;
sigmaL = 20;
vsl = 1.4;
vsg = 1.2;
vm = vsl+vsg;
d = 0.3;
visL = 20;
visG = 2;
P = 200;
e = 0.0006*d;
g = 32.2;

V = num2cell(hagedorn_brown_parameters(rhoL, sigmaL, vsl, vsg, d, visL, P));
[NLV, NGV, Nd, NL, CNL, HL_phi, phi, HL] = V{:};


rhos = rhoL*HL+rhoG*(1-HL);
dPdZ_el = rhos;

visS = visL^HL*visG^(1-HL);
rhon = (rhoL*vsl+rhoG*vsg)/vm;
NRe = 1488*rhon*vm*d/visS;
f = (1/(-1.8*log10(((e/d)/3.7)^1.11+(6.9/NRe))))^2; % Haaland

dPdZ_f = f*rhon^2*vm^2/(2*g*d*rhos); %lbf/cuft
dPdZ = (dPdZ_el + dPdZ_f)/144; %psi/ft
