clear all
close all
clc

figure 

NLv = 0.002:0.001:0.4;
CNLv = []; 

for NL = NLv

A1 = -2.698510E+00;
A2 = 1.584095E-01;
A3 = -5.509976E-01;
A4 = 5.478492E-01;
A5 = -1.219458E-01;
CNL = 10^(A1+A2*(log10(NL)+3)+A3*(log10(NL)+3)^2+A4*(log10(NL)+3)^3+A5*(log10(NL)+3)^4);

CNLv = [CNLv CNL];
end

loglog(NLv,CNLv)
title('Hagedorn & Brown')
xlabel('NL')
ylabel('CNL')
grid on

figure 

CAv = 2E-6:1E-6:5E-3;

HL_phiv = [];

for CA = CAv

B1 = -1.030658E-01;
B2 = 6.177740E-01;
B3 = -6.329460E-01;
B4 = 2.959800E-01;
B5 = -4.010000E-02;

HL_phi = B1+B2*(log10(CA)+6)+B3*(log10(CA)+6)^2+B4*(log10(CA)+6)^3+B5*(log10(CA)+6)^4;

HL_phiv = [HL_phiv HL_phi];

end

semilogx(CAv,HL_phiv)
title('Hagedorn & Brown')
xlabel('CA')
ylabel('HL/phi')
grid on


figure

CBv = 0.012:0.001:0.08;

phiv = [];

for CB = CBv
    
C1 = 9.116257E-01;
C2 = -4.821756E+00;
C3 = 1.232250E+03;
C4 = -2.225358E+04;
C5 = 1.161743E+05;
phi = C1+C2*CB+C3*CB^2+C4*CB^3+C5*CB^4;

phiv = [phiv phi];

end

plot(CBv,phiv)
title('Hagedorn & Brown')
xlabel('CB')
ylabel('phi')
grid on
