%clear all; close all; clc;
%hold all

function [qT, rhon] = helpfunction_bit(qL_SC, GLR, WC, API, yW, T_pc, P_pc, yG, T, P)

yO = 141.5/(API+131.5);
qG_SC = qL_SC*GLR; %scf/day
qW_SC = qL_SC*WC; % bbl/day
qO_SC = qL_SC*(1-WC); %bbl/day
GOR = qG_SC/qO_SC; %scf/stb
Bw = bw_mccain(P,T);
pb = p_bubble(GOR,yG,T,API);                                         % Bubble Point Pressure, psi
[Rs, Bo] = standing(yG, API, pb, P, T);
z = zfac4(T,P,T_pc,P_pc);                                             % Gas Compressibility
Bg = (14.7/P)*((T+459.67)/519.67)*z;            % cuft/scf
qG = qO_SC*(GOR-Rs)*Bg/(3600*24);               % cuft/sec
qO = 6.49*10^-5*qO_SC*Bo;                       % cuft/sec
qW = 6.49*10^-5*qW_SC*Bw;                       % cuft/sec
qL = qO + qW;                                   % cuft/sec
qT = qL + qG;                                   % cuft/sec
rhoG = 2.7*P*yG/(z*(T+459.67));                 % lbm/cuft
rhoO = (yO*62.4+yG*0.0764*Rs/5.614)/Bo;         % lbm/cuft
rhoW = yW*62.4/Bw;                              % lbm/cuft
fO = qO/(qO+qW);                                % -
fW = 1 - fO;                                    % -
rhoL = rhoO*fO + rhoW*fW;  %49.9;                        % lbm/cuft
lamdaL = qL/(qL+qG);                            % -
lamdaG = 1 - lamdaL;                            % -
rhon = rhoL*lamdaL+rhoG*lamdaG;  %15.8;         % Density, no-slip, lbm/cuft         % lbm/cuft

end
