function[qGin_SC, qWin_SC, qOin_SC, yG, API, yW] = inflowGUI(handles,BHP)


OHd = str2double(get(handles.edit99,'String'));
BitDepth = str2double(get(handles.edit100,'String'));

%% Reservoir Information
TOPOFRES = str2double(get(handles.edit101,'String'));
ResHeight = str2double(get(handles.edit103,'String'));
pr = str2double(get(handles.edit104,'String'));
TVDresAVG = TOPOFRES + ResHeight/2;
TempTable = get(handles.temptable, 'Data');
T = interp1(TempTable(:,1),TempTable(:,3),TVDresAVG);        % Temperature at btm of interval, Farenheit
GLR = str2double(get(handles.edit107,'String'));
API = str2double(get(handles.edit105,'String'));
yW = str2double(get(handles.edit114,'String'));
WC = str2double(get(handles.edit106,'String'));
xx = get(handles.popupmenu14, 'String');
yy = get(handles.popupmenu14, 'Value');
GOR = GLR/(1-WC); %scf/stb

GASTYPE = char(xx(yy));

switch GASTYPE
    case 'Custom'
        load yGinTEMP.mat
        yG = yGin;
    otherwise
        [~, yG, ~, ~] = gasprop(GASTYPE);
end

Bw = bw_mccain(pr,T);
pb = p_bubble(GOR,yG,T,API);
[Rs, Bo] = standing(yG, API, pb, pr, T);
fO = (1-WC)*Bo/((1-WC)*Bo+WC*Bw);
fW = 1 - fO;
B = fO*Bo+Bw*Bw;
visO = oilviscosity(API,T,Rs,pr,pb);             % cp
visW = waterviscosity(T);                       % cp
vis = visO*fO+visW*fW;                          % cp
           
IPRdata = get(handles.uitable18,'Data');
if length(IPRdata) == 3;
    choice = 'Known Reservoir Properties';
    k = IPRdata(1);
    re = IPRdata(2);
    S = IPRdata(3);
else
    choice = 'Known Maximum Flowrate';
    Qmax = IPRdata;
end

if BitDepth > TOPOFRES  
    
    PayZone = min(ResHeight, BitDepth-TOPOFRES);   
    
    switch choice
        case 'Known Maximum Flowrate'
            [qLin_SC, ~] = inflow(Qmax, BHP, pr, GLR);
        case 'Known Reservoir Properties'
            qLin_SC = vogeladvanced(k,PayZone,pr,BHP,pb,re,OHd/2,S,B,vis);
    end
    
    
else
    qLin_SC = 0;
end

qGin_SC = qLin_SC*GLR;      % scf/day
qWin_SC = qLin_SC*WC;       % bbl/day
qOin_SC = qLin_SC*(1-WC);   % bbl/day


end

