function vm = mixturevelocity(do, di, qL_SC, GLR, WC, API, T, P, yG, T_pc, P_pc)

    Area = pi/4*(do^2-di^2);
    qG_SC = qL_SC*GLR; %scf/day
    qW_SC = qL_SC*WC; % bbl/day
    qO_SC = qL_SC*(1-WC); %bbl/day
    GOR = qG_SC/qO_SC; %scf/stb
    Bw = bw_mccain(P,T);
    pb = p_bubble(GOR,yG,T,API);                                         % Bubble Point Pressure, psi
    [Rs, Bo] = standing(yG, API, pb, P, T); 
    z = zfac4(T,P,T_pc,P_pc);                       % Gas Compressibility
    Bg = (14.7/P)*((T+459.67)/519.67)*z;            % cuft/scf
    qG = qO_SC/(24*3600)*(GOR-Rs)*Bg;               % cuft/sec
    qO = 5.615/(24*3600)*qO_SC*Bo;                  % cuft/sec
    qW = 5.615/(24*3600)*qW_SC*Bw;                  % cuft/sec
    qL = qO + qW;                                   % cuft/sec
    vsg = qG/Area;                                  % ft/sec
    vsl = qL/Area;                                  % ft/sec
    vm = vsg + vsl;                                 % ft/sec

end
