hold all;
grid on
subplot(121)

[Mg, yG, T_pc, P_pc] = gasprop('CH4');

API = 35;

Tv = [90 120 150 200 250 300 400];

for T = Tv
    for GOR = 1:1500
            pb(GOR) = p_bubble(GOR,yG,T,API);                                         % Bubble Point Pressure, ps
    end
    plot(pb, 'DisplayName' , [num2str(T),'F'])
    hold all;
    axis([0 1500 0 15000])
    grid on
end

xlabel('GOR, scf/stb')

title('Bubble Point Pressure for Methane and 35 degrees API Oil')

ylabel('Bubble Point Pressure, psi')
subplot(122)
grid on

xlabel('GOR, scf/stb')
ylabel('Bubble Point Pressure, psi')
title('Bubble Point Pressure for Methane and Oil at 150F')
hold all
axis([0 1500 0 15000])

T = 150;

APIv = [5 10 20 30 40 50 60];


for API = APIv    
    for GOR = 1:1500
            pb(GOR) = p_bubble(GOR,yG,T,API);                                         % Bubble Point Pressure, psi
    end
    plot(pb, 'DisplayName' , ['API = ',num2str(API)])
end