clear all; close all; clc;

figure
subplot(121)

p = 0;
pb = inf;
Rs = 500;

APIv = 1:60;
Tv = 100:20:220;

for T = Tv
    for API = APIv
        visO(API) = oilviscosity(API,T,Rs,p,pb);
    end
    semilogy(APIv, visO(APIv),'DisplayName', [num2str(T),'F'])
    hold all
    grid on
end

xlabel('Oil Gravity, API')
ylabel('Viscosity, cp')
title('Dead Oil Viscosity for Rs = 500 scf/STB')






clear all;
subplot(122)

API = 35;
pb = 2500;
Rs = 500;

pv = 15:6000;
Tv = 100:20:220;

for T = Tv
    for p = pv
        visO(p) = oilviscosity(API,T,Rs,p,pb);
    end
    plot(pv, visO(pv),'DisplayName', [num2str(T),'F'])
    hold all
    grid on
end

xlabel('Pressure, psi')
ylabel('Viscosity, cp')
title('Live Oil Viscosity for API = 35 & Rs = 500 scf/stb')

















 
figure
clear all;

API = 35;
GASTYPE = 'CH4';
GOR = 500;

pv = 15:6000;
Tv = 100:20:220;

for T = Tv

    for p = pv
        [Mg, yG] = gasprop(GASTYPE);
        pb = p_bubble(GOR,yG,T,API);                                         % Bubble Point Pressure, psi
        [Rs, Bo] = standing(yG, API, pb, p, T);
        visO(p) = oilviscosity(API,T,Rs,p,pb);
    end

    plot(pv, visO(pv),'DisplayName', [num2str(T),'F'])
    hold all
    grid on

end

xlabel('Pressure, psi')
ylabel('Viscosity, cp')
title('Oil Viscosity for API = 35 & Methane with GOR = 500 scf/stb')