% Function calcultes bubble point pressure at a given temperature  
% based on Standings correlation for California crude oils
%   Ref     -   Whitson: p29

% Input:
% T     -   Temperature, F
% Rsi    -   GOR, scf/STB
% yg    -   Specific Gravity Gas
% API   -   API gravity 

% Output:
% pb    -   Bubble Point Pressure, psi

function pb = p_bubble(Rsi,yg,T,API)
    b = 0.00091*T - 0.0125*API;         
    A = (Rsi/yg)^0.83*10^b;
    pb = 18.2*(A-1.4);                  
end