%clear all; close all; clc;


%for API = [10 20 30 40 50] 
%for T = [100 150 200 250]
%for GOR = [100 250 1000 2500]    

for API = [15 30];

    GASTYPE = 'N2';

[Mg, yG] = gasprop(GASTYPE);

T = 150;
pb = 4000;


for p = 1:6000
    [Rs, Bo] = standing(yG, API, pb, p, T);
    k(p)=Bo;
end

plot(k, 'DisplayName', ['GAS: ',char(GASTYPE),', OIL: ',num2str(API),' API'])
hold all
grid on

end


axis([0 6000 1 2])

xlabel('Pressure, psi')
ylabel('FVF, RB/STB')
title('Oil Formation Volume Factor, Assumed Bubble Point Pressure @ 4000 psi & 150F') 