
%WC = str2double(get(handles.edit78, 'String'))/100;

%ai = 0;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

x = get(handles.popupmenu13, 'String');
correlationv = transpose(x);
v = get(handles.popupmenu13, 'Value');
correlation = char(correlationv(v));

e_rel = str2double(get(handles.edit113, 'String')); % Relative roughness
GLR = str2double(get(handles.edit109, 'String'));   % Producing gas-liquid ratio (GLR):	scf/stb
Psv = str2double(get(handles.edit68, 'String'));                                       % Back Pressure, psia
P_Choke = Psv;

switch MODE
    case 1
        % Do nothing
    case 5
        prompt = {'Minimum Surface Pressure, psi:','Maximum Surface Pressure, psi:','Step, psi:'};
        dlg_title = 'Input';
        num_lines = 1;
        def = {'0','500','100'};
        answer = inputdlg(prompt,dlg_title,num_lines,def);
        [a, b, c] = answer{:};
        PsMin = str2double(a);
        PsMax = str2double(b);
        PsStp = str2double(c);
        Psv = [PsMin:PsStp:PsMax];      
    otherwise
        prompt = {'Minimum Gas Flow, MMscf/day:','Maximum Gas Flow, MMscf/day:','Step Rate, MMscf/day:'};
        dlg_title = 'Input';
        num_lines = 1;
        def = {'0','5','0.25'};
        answer = inputdlg(prompt,dlg_title,num_lines,def);
        [a, b, c] = answer{:};
        qvMin = str2double(a);
        qvMax = str2double(b);
        qvStp = str2double(c);
        qG_SCv = [qvMin:qvStp:qvMax].*1000000;
        qG_SCv = [0:0.25:5 5.5:0.5:9.5 10:29 30:5:75].*1000000;
end

TempTable = get(handles.temptable, 'Data');
Geometry = get(handles.schematictot,'Data');
Welldata = get(handles.uitable8, 'Data');

GC = size(Geometry,1);

errorindicator = 0;

if max(Welldata,2)<Geometry(GC,1)
   errordlg('Survey Data not Defined for all Relevant Depths','Error');
   errorindicator = 1;
end
if max(TempTable,1)<Geometry(GC,1)
   errordlg('Temperature Data not Defined for all Relevant Depths','Error');
   errorindicator = 1;
end

if errorindicator
    return;
end

for i = 1:(size(Welldata,1))
    if Welldata(i,2)< Geometry(GC,1)
        indexmax = i+1;
        continue
    end
end

Welldata = Welldata(1:indexmax,:);

if Welldata(indexmax,2) > Geometry(GC,1)
    A = zeros(1,11);
    A(1) = indexmax;
    dMD  = Welldata(indexmax-1,2) - Welldata(indexmax,2);
    dInc = Welldata(indexmax-1,3) - Welldata(indexmax,3);
    dAzi = Welldata(indexmax-1,4) - Welldata(indexmax,4);
    DL = (Geometry(GC,1)-Welldata(indexmax-1,2))/dMD;
    A(2) = Welldata(indexmax-1,2) + dMD *DL;
    A(3) = Welldata(indexmax-1,3) + dInc*DL;
    A(4) = Welldata(indexmax-1,4) + dAzi*DL;
    Welldata = [Welldata(1:indexmax-1,:); A];
    Welldata = surveycalcfromtable(Welldata);   
end


switch MODE
    case 1
        x = get(handles.popupmenu7, 'String');
        qL_SCv = transpose(str2num(x));
        v = get(handles.popupmenu7, 'Value');
        qL_SCv = qL_SCv(v);
    otherwise
        x = get(handles.popupmenu7, 'String');
        qL_SCv = transpose(str2num(x));
end

x = get(handles.popupmenu8, 'String');
y = get(handles.popupmenu8, 'Value');
GASTYPE = char(x(y));
[Mg, yG, T_pc, P_pc] = gasprop(GASTYPE);
yW = str2double(get(handles.edit77, 'String'));
API = str2double(get(handles.edit81, 'String'));                                           % API Gravity Oil
WC = str2double(get(handles.edit78, 'String'))/100;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%for API = 10:10:50
%     for WC = [0 0.10 0.25 0.50 0.75]
%         for Psv = [125 250 500]
%             for GASc = 1:3
%                 
%                 if GASc == 1
%                     GASTYPE = 'CH4';
%                 elseif GASc == 2
%                     GASTYPE = 'AIR';
%                 else
%                     GASTYPE = 'C3H8';
%                 end
%                 
%             [Mg, yG, T_pc, P_pc] = gasprop(GASTYPE);
%             end

%DATA = [nan ; transpose(qG_SCv./1000000)];
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

for qL_SC = qL_SCv                  %	Liquid production rate:	2000	  stb/d
    
    %%%%%%%%%%%%%%%
    
    %%%%%%%%%%%%%%
    
    fric = [];
    dens = [];
    ptot = [];
    QualGas = [];
    QualGasS = [];
    GLRv = [];
    min_annular_velocity = [];
    qLin_SC = 0;
    qGin_SC = 0;
    qOin_SC = 0;
    qWin_SC = 0;
     
    switch MODE
        case 1
            h = waitbar(0,'Please wait...');
            annular_iteration
            drillstring_iteration
        case 5
            h = waitbar(0,'Please wait...');
            for P_Choke = Psv
                waitbar(P_Choke/500,h);
                annular_iteration
            end
        otherwise
            h = waitbar(0,'Please wait...');
            wbarc = 0;
            for qG_SC = qG_SCv;              
                wbarmax = length(qG_SCv);
                GLR = qG_SC/qL_SC;
                GLRv = [GLRv GLR];
                annular_iteration
                %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
                %drillstring_iteration
              
                %%%% SECTION SAVES PRESSURE RESULTS  TO XLS-FILE %%%%
                %ai = ai + 1;
                %simpara = real([P_Choke qL_SC API WC qG_SC GLR yG]);
                %a = real([P_Choke; ds_pavgA; BHP]);
                %d = real([0; ds_MDavg; ds_MDoutA(intervals)]);
                %s = real([PDS; transpose(ds_pavgD); BHP+dPbit]);
                
                %if ai == 1
                %    DATA = transpose([nan qG_SCv]);
                    %DATA = [DATA; nan qL_SC];% [nan(7,1) ; d];
                %end
                %DATA1 = [BHP];
                %DATA = [DATA ; DATA1];
                %DATA0 = transpose(simpara); %[nan(7,1), transpose(simpara)];
                %DATA1 = [a]; %, s];
                %DATAc = [DATA0; DATA1];
                %DATA = [DATA DATAc];
                %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
                wbarc = wbarc + 1;
                waitbar(wbarc/wbarmax,h)
            end
            %DATA1 = [qL_SC; transpose(ptot)];
            %DATA = [DATA DATA1];
    end
    waitbar(1,h,'Simulation Done. Plotting Result')
    close(h)
    plotUBDsim
    %ai = 0;
end


%xlsflname = 'NEWXLS-UBDStaticSim.xls';
%xlswrite(xlsflname, DATA, correlation);
                

%xlsflname = 'XLS-UBDStaticSim.xls';
%xlswrite(xlsflname, DATA, correlation)

switch MODE
    case 1
        subplot(154)
        pr = str2double(get(handles.edit104,'String'));
        hx = graph2d.constantline(pr,'DisplayName','Reservoir Pressure','LineStyle',':','LineWidth',2,'Color',[1 0 0]);
        changedependvar(hx,'x');
    case 2
        pr = str2double(get(handles.edit104,'String'));
        hy = graph2d.constantline(pr,'DisplayName','Reservoir Pressure','LineStyle',':','LineWidth',2,'Color',[1 0 0]);
        changedependvar(hy,'y');
    case 3
        pr = str2double(get(handles.edit104,'String'));
        hy = graph2d.constantline(pr,'DisplayName','Reservoir Pressure','LineStyle',':','LineWidth',2,'Color',[1 0 0]);
        changedependvar(hy,'y');
    case 4
        % Do nothing
    case 5
        subplot(2,1,1)
        pr = str2double(get(handles.edit104,'String'));
        hy = graph2d.constantline(pr,'DisplayName','Reservoir Pressure','LineStyle',':','LineWidth',2,'Color',[1 0 0]);
        changedependvar(hy,'y');
end


%%%% SECTION SAVES PRESSURE RESULTS  TO XLS-FILE %%%%
% if MODE == 1
%     a = ds_pavgA;
%     d = ds_MDavg;
%     s = transpose(ds_pavgD);
%     DATA = [0 P_Choke PDS; 
%         d a s;
%         ds_MDoutA(intervals) BHP BHP+dPbit];
%     xlsflname = ['XLS-UBDStaticSim', correlation,'.xls'];
%     xlswrite(xlsflname, DATA)
% end