
%% This Section Plots the Results

subplot(141)
plot(ds_dHS*12, ds_MDavg, ds_doDS*12, ds_MDavg, ds_diDS*12, ds_MDavg)
set(gca,'YDir','reverse')
title('Diameter Deviated Well')
xlabel('Diameter, in')
ylabel('Measured Depth, ft')
legend('ID Casing','OD Drill Pipe', 'ID Drill Pipe')
grid on
subplot(142)
plot(ds_dPdZA, ds_MDavg, 'r', ds_dPdZD, ds_MDavg, 'b')
set(gca,'YDir','reverse')
title('Pressure Gradient Deviated Well')
xlabel('Pressure, psi/ft')
ylabel('Measured Depth, ft')
legend('Annulus', 'Drill String')
grid on
subplot(143)
plot(ds_pavgA, ds_MDavg, 'r', ds_pavgD, ds_MDavg, 'b')
set(gca,'YDir','reverse')
title('Pressure Profile Deviated Well')
xlabel('Pressure, psi')
ylabel('Measured Depth, ft')
legend('Annulus', 'Drill String')
grid on
subplot(144)
plot(Vsec, ds_TVDavg, 'r')
set(gca,'YDir','reverse')
title('Well Trajectory')
xlabel('Vertical Section, ft')
ylabel('True Vertical Depth, ft')
xmin = min(Vsec)-100;
xmax = max(Vsec)+100;
xlim([xmin xmax])
legend('Well')
grid on
