
A = get(handles.uitable1, 'Data');
pv = A(:,1);

wbarc = 0;
wbarmax = 15;
h = waitbar(wbarc/wbarmax,'Please Wait. Plotting Results.');

%%%%%%%%%%% CONSTANTS %%%%%%%%%%%%%%%%%
%T = A(:,2);
%Area = A(:,3);
%do = A(:,4);
%di = A(:,5);
%dh = A(:,6);
%API = A(:,7);
%Mg = A(:,8);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

axes(handles.axes1)
z = A(:,11);
plot(pv, z)
grid on
legend('Z')
xlabel('Pressure, psia')
ylabel('Z-factor, -')
wbarc = wbarc+1;
waitbar(wbarc/wbarmax,h)

axes(handles.axes2)
Rs = A(:,12);
plot(pv, Rs)
grid on
legend('Rs')
title('Title')
xlabel('Pressure, psia')
ylabel('Solution GOR, cuft/stb')
wbarc = wbarc+1;
waitbar(wbarc/wbarmax,h)

axes(handles.axes3)
Bo = A(:,13);
Bw = A(:,14);
Bg = A(:,15);
plot(pv, [Bo Bw Bg])
grid on
legend('Oil', 'Water', 'Gas')
xlabel('Pressure, psia')
ylabel('FVF, -')
wbarc = wbarc+1;
waitbar(wbarc/wbarmax,h)

axes(handles.axes4)
qO = A(:,16);
qW = A(:,17);
qG = A(:,18);
qL = A(:,19);
qT = A(:,20);
plot(pv, [qO qW qG qL qT])
grid on
legend('Oil', 'Water', 'Gas', 'Liquid', 'Total')
xlabel('Pressure, psia')
ylabel('Flow Rate, cuft/sec')
wbarc = wbarc+1;
waitbar(wbarc/wbarmax,h)

axes(handles.axes5)
lamdaL = A(:,21);
lamdaG = A(:,22);
HL = A(:,23);
HG = A(:,24);
fO = A(:,25);
fW = A(:,26);
plot(pv, [lamdaL lamdaG HL HG fO fW])
grid on
legend('lamdaL', 'lamdaG', 'HL', 'HG', 'fO', 'fW')
xlabel('Pressure, psia')
ylabel('Ratio, -')
wbarc = wbarc+1;
waitbar(wbarc/wbarmax,h)

axes(handles.axes6)
rhoO = A(:,27);
rhoW = A(:,28);
rhoG = A(:,29);
rhoL = A(:,30);
rhon = A(:,31);
rhos = A(:,32);
rhok = A(:,33);
plot(pv, [rhoO rhoW rhoG rhoL rhon rhos rhok])
grid on
legend('Oil', 'Water', 'Gas', 'Liquid', 'No-slip', 'Slip', 'k----')
xlabel('Pressure, psia')
ylabel('Density, lbm/cuft')
wbarc = wbarc+1;
waitbar(wbarc/wbarmax,h)

axes(handles.axes7)
VolumeO = A(:,34);
VolumeW = A(:,35);
VolumeG = A(:,36);
VolumeL = A(:,37);
VolumeT = A(:,38);
plot(pv, [VolumeO VolumeW VolumeG VolumeL VolumeT])
grid on
legend('Oil', 'Water', 'Gas', 'Liquid', 'Total')
xlabel('Pressure, psia')
ylabel('Volume, cuft/stb')
wbarc = wbarc+1;
waitbar(wbarc/wbarmax,h)

axes(handles.axes8)
VolumeO = A(:,34);
VolumeW = A(:,35);
VolumeG = A(:,36);
area(pv, [VolumeO VolumeW VolumeG])
grid on
legend('Oil', 'Water', 'Gas')
xlabel('Pressure, psia')
ylabel('Cumulative Volume, cuft/stb')
wbarc = wbarc+1;
waitbar(wbarc/wbarmax,h)


axes(handles.axes9)
visO = A(:,44);
visW = A(:,45);
visG = A(:,46);
visL = A(:,47);
visn = A(:,48);
viss = A(:,49);
plot(pv, [visO visW visG visL visn viss])
grid on
legend('Oil', 'Water', 'Gas', 'Liquid', 'No-slip', 'Slip')
xlabel('Pressure, psia')
ylabel('Viscosity, cp')
wbarc = wbarc+1;
waitbar(wbarc/wbarmax,h)

axes(handles.axes10)
sigmaO = A(:,50);
sigmaW = A(:,51);
sigmaL = A(:,52);
plot(pv, [sigmaO sigmaW sigmaL])
grid on
legend('Oil', 'Water', 'Liquid')
xlabel('Pressure, psia')
ylabel('Interfacial Tension, dynes/cm^2')
wbarc = wbarc+1;
waitbar(wbarc/wbarmax,h)

axes(handles.axes11)
vsl = A(:,53);
vsg = A(:,54);
vm = A(:,55);
vl = A(:,56);
vg = A(:,57);
vs = A(:,58);
plot(pv, [vsl vsg vm vl vg vs])
grid on
legend('Superficial Liquid', 'Superficial Gas', 'Mixture', 'Liquid', 'Gas', 'Slip')
xlabel('Pressure, psia')
ylabel('Velocity, ft/sec')
wbarc = wbarc+1;
waitbar(wbarc/wbarmax,h)

axes(handles.axes12)
ff = A(:,59);
plot(pv, ff)
grid on
legend('Friction Factor')
xlabel('Pressure, psia')
ylabel('Friction Factor')
wbarc = wbarc+1;
waitbar(wbarc/wbarmax,h)

axes(handles.axes13)
NRen = A(:,60);
NRes = A(:,61);
plot(pv, [NRen NRes])
grid on
legend('No-Slip','Slip')
xlabel('Pressure, psia')
ylabel('Reynolds Number')
wbarc = wbarc+1;
waitbar(wbarc/wbarmax,h)

axes(handles.axes14)
dPdZh = A(:,62);
dPdZf = A(:,63);
dPdZa = A(:,64);
dPdZt = A(:,65);
plot(pv, [dPdZh dPdZf dPdZa dPdZt])
grid on
legend('Hydrostatic', 'Friction', 'Acceleration', 'Total')
xlabel('Pressure, psia')
ylabel('Pressure Gradient, psi/ft')
wbarc = wbarc+1;
waitbar(wbarc/wbarmax,h)

axes(handles.axes15)
dPdZh = A(:,62);
dPdZf = A(:,63);
dPdZa = A(:,64);
dPdZt = A(:,65);
PG = [dPdZh, dPdZf, dPdZa];
area(pv,PG)
grid on
legend('Hydrostatic', 'Friction', 'Acceleration')
xlabel('Pressure, psia')
ylabel('Pressure Gradient, psi/ft')
wbarc = wbarc+1;
waitbar(wbarc/wbarmax,h)



close(h)