%%%%%%%%%%%%%%%%%%%
%pin = 500;
%L = 5000;
%dP_guess = 0;
%dev = 10;
%%%%%%%%%%%%%%%%%%%%%%%%

%while dev>0.01
    
% pout = pin + dP_guess;
% pavg = (pin+pout)/2;
    
d = 1.66; %	Tubing ID:	1.66	  in
p = 500; %	Wellhead pressure:	500	  psia
qL = 2000; %	Liquid production rate:	2000	  stb/d
GLR = 1000; %	Producing gas-liquid ratio (GLR):	1000	  scf/stb
WC = 0.25; %	Water cut (WC):	25	  %
API = 30; %	Oil gravity:	30	  oAPI
yW = 1.05; %	Water specific gravity:	1.05	  1 for fresh water
yG = 0.65; %	Gas specific gravity:	0.65	  1 for air

Bw = 1.2; %Formation volume factor for water:	1.2	  rb/stb
T = 150; %	Wellhead temperature:	100	  oF

qG = qL*GLR; %scf/day
qW = qL*WC; % bbl/day
qO = qL*(1-WC); %bbl/day
WOR = qW/qO;%bbl/stb
GOR = qG/qO; %scf/stb

rhoAIR = 0.0765;
yO = 141.5/(API+131.5);
M = 350.17*(yO+WOR*yW)+GOR*rhoAIR*yG;
Rs = yG*(p/18*10^(0.0125*API)/10^(0.00091*T))^1.2048;
Bo = 0.971 + 0.000147*(Rs*(yG/yO)^0.5+1.25*T)^1.175;
z = 0.95;
Vm = 5.615*(Bo+WOR*Bw)+(GOR-Rs)*(14.7/p)*((T+460.67)/520)*z;

rhon = M/Vm;

D_rho_v = 1.4737*10^-5*M*qO/(d/12);
f = 4*10^(1.444-2.5*log10(D_rho_v));

k = f*qO^2*M^2/7.4137/10000000000/(d/12)^5;
dPdZ_f = k/rhon;
dPdZ_el = rhon;
dPdZ = (dPdZ_f + dPdZ_el)/144;    %psi/ft
% 
% %%%%%%%%%%%%%%
% dP_calc = dPdZ*L; 
% dev = dP_calc - dP_guess;
% dP_guess = dP_guess + 0.8*dev;
% %%%%%%%%%%%%%
% end
% % %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% % vsg = 4.09; %ft/sec
% vsl = 2.65; %ft/sec
% wm = 7.87; % lbm/sec
% rhoL = 56.6; %lbm/cuft
% rhoG = 2.84; %lbm/cuft
% vm = vsg + vsl; %ft/sec
% lamdaL = vsl/vm;
% lamdaG = 1 - lamdaL;
% rhon = rhoL*lamdaL + rhoG*lamdaG; %lbm/cuft
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%