%% Section Places Well Data Into Vectors
intervals   = size(Welldata, 1)-1;                  % Number of intervals in data
ds_Interval = transpose(1:intervals);               % Numbers interval
ds_MDoutA   = double(Welldata(2:intervals+1,2));    % Measured depth annular outflow, ft
ds_MDinA    = double(Welldata(1:intervals,2));      % Measured depth annular inflow, ft
ds_TVDoutA  = double(Welldata(2:intervals+1,5));    % TVD annular outflow, ft 
ds_TVDinA   = double(Welldata(1:intervals,5));      % TVD annular inflow, ft 
ds_MDoutD   = double(Welldata(1:intervals,2));      % Measured depth drill string outflow, ft
ds_MDinD    = double(Welldata(2:intervals+1,2));    % Measured depth drill string inflow, ft
ds_TVDoutD  = double(Welldata(1:intervals,5));      % TVD drill string outflow, ft 
ds_TVDinD   = double(Welldata(2:intervals+1,5));    % TVD drill string inflow, ft 
ds_MDavg = (ds_MDinA + ds_MDoutA)/2;                % Average measured depth, ft
ds_Vsecin = double(Welldata(1:intervals,11));       % Vertical Section Top, ft
ds_Vsecout = double(Welldata(2:intervals+1,11));    % Vertical Section Bottom, ft
Vsec = (ds_Vsecin+ds_Vsecout)/2;                    % Average Vertical Section, ft

for i = 1:intervals      
    MD = ds_MDoutA(i);
    found = 0;
    index = 1;
    while found == 0;
        if Geometry(index,1)<(MD-0.001);
            index = index + 1;
        else
            found = 1;
        end
    end
    d1 = Geometry(index,2)/12;
    d2 = Geometry(index,3)/12;
    d3 = Geometry(index,4)/12;
    ds_diDS(i) = d1;
    ds_doDS(i) = d2;
    ds_dHS(i) = d3;
end

ds_dp_guessA = zeros(intervals,1);                  % First annular pressure change guessed, psi
ds_dZ = abs(ds_MDoutA - ds_MDinA);                  % Length of interval, ft
ds_dhA = ds_TVDoutA - ds_TVDinA;                    % Depth change interval, ft
ds_phiA = asind(ds_dhA./ds_dZ);                     % Calculted Inclination, degrees
ds_TVDavg = (ds_TVDinA + ds_TVDoutA)/2;             % Average TVD, ft
TA = interp1(TempTable(:,1),TempTable(:,3),ds_TVDavg);
TP = interp1(TempTable(:,1),TempTable(:,2),ds_TVDavg);
ds_TavgFP = TP;
ds_TavgF = TA; %Tsurf + ds_TVDavg.*TempGrad;        % Average temperature, F
ds_iterA = zeros(intervals, 1);                     % Iteration Counter
ds_ADS = pi/4*ds_diDS.^2;                           % Flow Area Drill String, sqft
ds_Aann = pi/4*(ds_dHS.^2-ds_doDS.^2);              % Flow Area Annulus, sqft
ds_dPA = zeros(intervals, 1);                       % Pressure Change, psi
ds_poutA = zeros(intervals, 1);                     % Define Outflow Pressure Annulus, psi
ds_pinA = zeros(intervals, 1);                      % Define Inflow Pressure Annulus, psi
ds_pavgA = zeros(intervals, 1);                     % Calculated pressure defined, psi
ds_dPdZA = zeros(intervals, 1);                     % Annular Pressure Gradient Defined, psi/ft
ds_dp_guessD = zeros(intervals,1);                  % First string pressure change guessed, psi
ds_dhD = ds_TVDoutD - ds_TVDinD;                    % Depth change interval, ft
ds_phiD = asind(ds_dhD./ds_dZ);                     % Calculted Inclination, degrees
ds_iterD = zeros(intervals, 1);                     % Iteration Counter
ds_dPD = zeros(intervals, 1);                       % Pressure Change, psi
