%% Mixture Properties

qG_SC = qL_SC*GLR; %scf/day
qW_SC = qL_SC*WC; % bbl/day
qO_SC = qL_SC*(1-WC); %bbl/day

APIin = str2double(get(handles.edit105,'String'));
yWin = str2double(get(handles.edit114,'String'));
[~, yGin, ~, ~] = gasprop(GASTYPE);


yO = 141.5/(API+131.5);
yOin = 141.5/(APIin+131.5);

qL_SCmix = qL_SC + qLin_SC;
qG_SCmix = qG_SC + qGin_SC;
qO_SCmix = qO_SC + qOin_SC;
qW_SCmix = qW_SC + qWin_SC;

yGmix = (qG_SC*yG + qGin_SC*yGin)/qG_SCmix;
yOmix = (qO_SC*yO + qOin_SC*yOin)/qO_SCmix;
yWmix = (qW_SC*yW + qWin_SC*yWin)/qW_SCmix;

if isnan(yGmix)
    yGmix = yG;
end
if isnan(yOmix)
    yOmix = yO;
end
if isnan(yWmix)
    yWmix = yW;
end

GLRmix = qG_SCmix/qL_SCmix;
WCmix = qW_SCmix/qL_SCmix;
APImix = 141.5/yOmix - 131.5;
Mgmix = 28.97*yGmix;
[T_pcmix, P_pcmix] = sutton(yGmix);

%timemax = 5;
        A = ones(intervals,timemax);

        for tA = 1:timemax  
            ShiftRate = 2;    
            if tA>1
            A(:,tA) = A(:,tA-1);
            end
            A(:,tA) = shift(A(:,tA),ShiftRate);
            A((intervals-ShiftRate+1):intervals,tA) = tA*ones(ShiftRate,1);
        end



%% Section Simulates Fluid Flow Up Annulus
% Simulated against flow direction  - Positive pressure gradient
        
for ii = 1:intervals                                                      % Loop over all intervals  
    if MODE == 1;
        wbarc = wbarc + 1;
        waitbar(wbarc/wbarmax,h)
    end
    deviation = 1000;                                                       % Define Pressure deviation, psi
    ds_iterA(ii) = 0;                                                       % Initiate Interval Iteration Counter
    while(abs(deviation)>limit)                                           % Checks if iteration limit is reached
        
        ds_iterA(ii) = ds_iterA(ii) + 1;                                    % Iteration Counter Increases
        
        % Section Estimates the Average Pressure
        if (ii>1)
            ds_pinA(ii) = ds_poutA(ii-1);                                   % Inlet Pressure Equals Outles Pressure Last Interval
        else
            ds_pinA(ii) = P_Choke;                                          % Inlet Pressure Equals Choke Pressure at Surface
        end
        ds_poutA(ii) = ds_pinA(ii) + ds_dp_guessA(ii);                      % Calculates Outlet Pressure from Inlet and Guessed Change, psi
        ds_pavgA(ii) = (ds_pinA(ii) + ds_poutA(ii))/2;                      % Average Pressure, psi      
        
        do = ds_dHS(ii);
        inc = ds_phiA(ii);
        di = ds_doDS(ii);
        T = ds_TavgF(ii);
        P = ds_pavgA(ii);
        
        FluidpropSS(t,:) = [qL_SCmix, GLRmix, WCmix, APImix, yWmix, Mgmix, yGmix, T_pcmix, P_pcmix];
        
        adjustedtime = A(ii,t);
        FluidpropDYN(t,:) = FluidpropSS(adjustedtime,:);
            
        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
         % Section Find Which Timestep,t, the Flow in Interval, i, Corresponds to
%                 % ASSUMPTION, Only lower interval produces formation fluid
%                 % time - Correct Inflow  
%                 dt = 60;                                                    % Length of Timestep, sec
%                 M_influx(ii,t) = qTss(intervals,t)*dt.*rhoMss(intervals,t); % Mass Influx of Current Timestep, lbm/min
%                 Vol(ii) = dst(ii,12).*dst(ii,4);                            % Volume Capacity of Current Interval, ft3
%                 Mass_cap(ii,t) = Vol(ii)*rhoMss(ii,t);                      % Mass Capacity of Current Influx/Interval, lbm
%                 ShiftRate(ii,t) = M_influx(ii,t)./Mass_cap(ii,t);           % Number of Intervals Influx Fills
%                 k = find(isnan(ShiftRate));                                 % Replaces Dummy Data 
%                 ShiftRate(k) = 0;
% 
%                 time = t;                                                   % Assumes Current Influx Fills Current Interval
% 
%                 if time>1                                                   % At First Timestep No Flow Has Shifted
%                     A(:,time) = A(:,time-1);                                % Collects Flow Posistion From Last Timestep
%                     A(:,time) = shift(A(:,time),round(ShiftRate(time)));    % Shifts Flow Posistion Upwards in Annulus
%                 end
% 
%                 FirstZeroElement = intervals -round(ShiftRate(time)-1);     % Finds First Interval Not Filled With Current Influx  
%                 if (FirstZeroElement<1)                                     % If Entire Well is Filled With Current Inflow...
%                     FirstZeroElement = 1;                                   % .. Assign First Interval (top) to Be Top of Influx
%                 end
%                 A(FirstZeroElement:intervals,time) = time;                  % Assignes Current Inflow To All Affected (Lower) Intervals
%                 time = A(ii,t);                                             % Assigns Correct Influx to Correct Interval and Time
% 
%                 if time>0
%                     qG(ii,t) = qGss(ii,time);                               % Gas Flow Rate, cuft/sec
%                     qO(ii,t) = qOss(ii,time);                               % Liquid Flow Rate, cuft/sec
%                     qT(ii,t) = qTss(ii,time);                               % Total Flow Rate, cuft/sec
%                     rhoL(ii,t) = rhoOss(ii,time);                           % Liquid Density, lbm/cuft
%                     rhoG(ii,t) = rhoGss(ii,time);                           % Gas Density, lbm/cuft
%                     rhoM(ii,t) = rhoMss(ii,time);                           % Mixture Density, lbm/cuft
%                 else
%                     qG(ii,t) = qGss(ii,1);                                  % Gas Flow Rate, cuft/sec
%                     qO(ii,t) = qOss(ii,1);                                  % Liquid Flow Rate, cuft/sec
%                     qT(ii,t) = qTss(ii,1);                                  % Total Flow Rate, cuft/sec
%                     rhoL(ii,t) = rhoOss(ii,1);                              % Liquid Density, lbm/cuft
%                     rhoG(ii,t) = rhoGss(ii,1);                              % Gas Density, lbm/cuft
%                     rhoM(ii,t) = rhoMss(ii,1);                              % Mixture Density, lbm/cuft
%                 end
 
        
        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        
        qL_SCmix = FluidpropDYN(t,1);
        GLRmix = FluidpropDYN(t,2);
        WCmix = FluidpropDYN(t,3);
        APImix = FluidpropDYN(t,4);
        yWmix = FluidpropDYN(t,5);
        Mgmix = FluidpropDYN(t,6);
        yGmix = FluidpropDYN(t,7);
        T_pcmix = FluidpropDYN(t,8);
        P_pcmix = FluidpropDYN(t,9);
        
        vectorout(ii,:) = cor_input_MANY(do, inc, di, qL_SCmix, GLRmix, WCmix, APImix, yWmix, T, P, Mgmix, yGmix, T_pcmix, P_pcmix, e_rel, correlation);
        ds_dPdZA(ii) = vectorout(ii,1); %(cor_input(do, inc, di, qL_SC, GLR, WC, API, yW, yG, T, P);
        ds_dPdP_FF(ii) = vectorout(ii,3).*ds_dZ(ii);                              % Calculated Pressure Change Over Interval, psi
        ds_dPdP_MW(ii) = vectorout(ii,2).*ds_dZ(ii);              % Calculated Pressure Change Over Interval, psi

                
        ds_dPA(ii) = ds_dPdZA(ii).*ds_dZ(ii);                               % Calculated Pressure Change Over Interval, psi
        deviation = ds_dp_guessA(ii)-ds_dPA(ii);                            % Pressure Deviation From Guess, psi 
        ds_dp_guessA(ii) = ds_dPA(ii);                                      % New Guess Pressure Change (next iteration), psi
        
        % Section Tries Average Value of Two Iterations if Convergence Fails
        if (ds_iterA(ii) == 201)
            dev1 = deviation;                                               % Holds Calculated Deviation
            val1 = ds_dp_guessA(ii);                                        % Holds Calculated Pressure
        elseif (ds_iterA(ii) == 202)
            dev2 = deviation;                                               % Holds Calculated Deviation, psi
            val2 = ds_dp_guessA(ii);                                        % Holds Calculated Pressure, psi
            ds_dp_guessA(ii) = mean([val1 val2]);                           % Average Pressure of Two Last Iterations, psi
            deviation = mean([dev1 dev2]);                                  % Average Deviation of Two Last Iterations, psi
        end
           
    end
    ds_poutA(ii) = ds_pinA(ii) + ds_dPA(ii);                                % Outlet Pressure of Interval, psi

end

BHP = ds_poutA(intervals);                                            % Estimated BHP (Outlet Pressure Last Interval), psi
%%%%%%%%%%%%%%%%
[qGin_SC, qWin_SC, qOin_SC, yGin, APIin, yWin] = inflowGUI(handles,BHP);
qLin_SC = qWin_SC + qWin_SC;
%%%%%%%%%%%%%%%

inflowdev = qL_SCmix-(qLin_SC+qL_SC)


if (abs(inflowdev) < 0.01)
    balanced = 1;
end

if inflowdevcounter == 1;
    maxhh = abs(inflowdev);
end
    
if balanced
    close(hh)
    fric = [fric sum(ds_dPdP_FF)];
    dens = [dens sum(ds_dPdP_MW)];
    ptot = [ptot BHP];
    QualGas = [QualGas vectorout(intervals,5)];
    QualGasS = [QualGasS vectorout(1,5)];
else
   waitbar(0,h)
   hval = 1-(log(inflowdev)-log(0.01))/(log(maxhh)-log(0.01));
   waitbar(hval,hh)
end





