

TempTable = get(handles.temptable, 'Data');
Geometry = get(handles.schematictot,'Data');
Welldata = get(handles.uitable8, 'Data');

GC = size(Geometry,1);

errorindicator = 0;

if max(Welldata,2)<Geometry(GC,1)
   errordlg('Survey Data not Defined for all Relevant Depths','Error');
   errorindicator = 1;
end
if max(TempTable,1)<Geometry(GC,1)
   errordlg('Temperature Data not Defined for all Relevant Depths','Error');
   errorindicator = 1;
end

if errorindicator
    return;
end

for i = 1:(size(Welldata,1))
    if Welldata(i,2)< Geometry(GC,1)
        indexmax = i+1;
        continue
    end
end

Welldata = Welldata(1:indexmax,:);

if Welldata(indexmax,2) > Geometry(GC,1)
    A = zeros(1,11);
    A(1) = indexmax;
    dMD  = Welldata(indexmax-1,2) - Welldata(indexmax,2);
    dInc = Welldata(indexmax-1,3) - Welldata(indexmax,3);
    dAzi = Welldata(indexmax-1,4) - Welldata(indexmax,4);
    DL = (Geometry(GC,1)-Welldata(indexmax-1,2))/dMD;
    A(2) = Welldata(indexmax-1,2) + dMD *DL;
    A(3) = Welldata(indexmax-1,3) + dInc*DL;
    A(4) = Welldata(indexmax-1,4) + dAzi*DL;
    Welldata = [Welldata(1:indexmax-1,:); A];
    Welldata = surveycalcfromtable(Welldata);   
end


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


g = 32.2;

xx = get(handles.popupmenu12, 'String');
yy = get(handles.popupmenu12, 'Value');
GASTYPE = char(xx(yy));
[~, Sg, ~, ~] = gasprop(GASTYPE);


xx = get(handles.popupmenu18, 'String');
yy = get(handles.popupmenu18, 'Value');
Correlation = char(xx(yy));




switch TYPE
    case 1
        Psv = str2double(get(handles.editF3, 'String'));             % Surface Pressure, psi
    case 2
        prompt = {'Minimum Surface Pressure, psi:','Maximum Surface Pressure, psi:','Step, psi:'};
        dlg_title = 'Input';
        num_lines = 1;
        def = {'100','500','100'};
        answer = inputdlg(prompt,dlg_title,num_lines,def);
        [a, b, c] = answer{:};
        PsMin = str2double(a);
        PsMax = str2double(b);
        PsStp = str2double(c);
        Psv = [PsMin:PsStp:PsMax];     
    otherwise
        Psv = str2double(get(handles.editF3, 'String'));             % Surface Pressure, psi
        prompt = {'Minimum Gas Flow, scf/min:','Maximum Gas Flow, scf/min:','Step Rate, scf/min:'};
        dlg_title = 'Input';
        num_lines = 1;
        def = {'100','3000','100'};
        answer = inputdlg(prompt,dlg_title,num_lines,def);
        [a, b, c] = answer{:};
        qvMin = str2double(a);
        qvMax = str2double(b);
        qvStp = str2double(c);
        qG_SC = [qvMin:qvStp:qvMax];
end

x = get(handles.editF1, 'String');
% y = get(handles.editF1, 'Value');

data = transpose(str2num(x));
% if TYPE == 1
%     data = data(y);
% end

for Ql = data
    
c = 0;
h = waitbar(0,'Please wait...');


switch TYPE
    case 1
        Qmaxv = str2double(get(handles.editF4, 'String'))/100;       % Max Gas Quality
        wcounter = 0;
    case 2
        Qmaxv = str2double(get(handles.editF4, 'String'))/100;       % Max Gas Quality
        wmax = length(Psv);
        wcounter = 0;
end

for Ps = Psv
%c = c + 1;
        
yL = str2double(get(handles.editF5, 'String'))*62.4;        % Liquid Density
Qf = str2double(get(handles.editF7, 'String'));             % Formation Influx Water, bbl/hr
ROP = str2double(get(handles.editF8, 'String'));            % ROP, ft/hr
Cs = str2double(get(handles.editF9, 'String'))/100;         % CuttingsCons
Ds = str2double(get(handles.editF10, 'String'));            % CuttingsSize
SGc = str2double(get(handles.editF11, 'String'));           % Cuttings Density
    
YP = str2double(get(handles.editF12, 'String'));
PV = str2double(get(handles.edit123, 'String'))/1488;
visL = PV;
        
switch TYPE
    case 5
        GLR = qG_SC./Ql; % scf/gal
        Qmaxv = GLR./(((1/7.48)+(5.615*Qf/(60*Ql)))+GLR);
        wmax = length(Qmaxv);
        wcounter = 0;
    case 4
        GLR = qG_SC./Ql; % scf/gal
        Qmaxv = GLR./(((1/7.48)+(5.615*Qf/(60*Ql)))+GLR);
        wmax = length(Qmaxv);
        wcounter = 0;
    case 3
        GLR = qG_SC./Ql; % scf/gal
        Qmaxv = GLR./(((1/7.48)+(5.615*Qf/(60*Ql)))+GLR);
        wmax = length(Qmaxv);
        wcounter = 0;
end


for Qmax = Qmaxv
c = c + 1;
wcounter = wcounter + 1;
preparegrid

switch TYPE
    case 2
        waitbar(wcounter/wmax,h)
    case 3
        waitbar(wcounter/wmax,h)
    case 4
        waitbar(wcounter/wmax,h)
    case 5
        waitbar(wcounter/wmax,h)
end


for ii = 1:intervals
    
    if TYPE == 1
        waitbar(ii/intervals,h)
    end

    inc = ds_phiA(ii);
    OD = ds_dHS(ii)*12;
    ID = ds_doDS(ii)*12;
    MDtop = ds_MDinA(ii);
    MDbtm = ds_MDoutA(ii);
    Tin = interp1(TempTable(:,1),TempTable(:,3),MDtop);
    Tout = interp1(TempTable(:,1),TempTable(:,3),MDbtm);
    D = MDbtm - MDtop;
    
    if ii == 1;
        Qin = Qmax;
        Pin = Ps;
    else
        Qin = Qout;
        Pin = Pout;
    end
    
    [Qout, Pout, yin, yout, CleaningFactor,vf,dPdL_el,dPdL_f] = foamval(OD,ID,inc,Cs,Ds,SGc,yL,Sg,Qf,ROP,Pin,Ql,D,Tin,Tout,Qin,e_rel,YP,PV,visL,Correlation);
    VECTOR(ii,:) = [MDbtm, Qout, Pout, yin, yout, CleaningFactor,vf,dPdL_el, dPdL_f];


   
end
Phyd(c) = sum(VECTOR(:,8));
Pfric(c) = sum(VECTOR(:,9));
BHP(c) = Pout;
QVbtm(c) = Qout;
QVtop(c) = Qmax; 
end
end

waitbar(1,h,'Simulation Done. Plotting Results')
close(h)

%% PLOTTING
Cleaning = VECTOR(intervals,6);
if Cleaning < 1;
    a = ':';
else
    a = '-';
end

switch TYPE
    case 1
        AX1 = subplot(1, 4, 1, 'Parent', handles.uipanel88);
        hold all
        plot(VECTOR(:,3),VECTOR(:,1), 'DisplayName', [num2str(round(Ql)) ' gal/min'], 'LineStyle', a)
        grid on
        set(gca, 'YDir', 'reverse');
        xlabel('Pressure, psi')
        ylabel('Depth, ft')
        AX2 = subplot(1, 4, 2, 'Parent', handles.uipanel88);
        hold all
        plot(VECTOR(:,2),VECTOR(:,1), 'DisplayName', [num2str(round(Ql)) ' gal/min'], 'LineStyle', a)
        grid on
        set(gca, 'YDir', 'reverse');
        xlabel('Foam Quality')
        %set(gca,'YTick',[]);
        %ylabel('Depth, ft')
        AX3 = subplot(1, 4, 3, 'Parent', handles.uipanel88);
        hold all
        plot(VECTOR(:,5),VECTOR(:,1), 'DisplayName', [num2str(round(Ql)) ' gal/min'], 'LineStyle', a)
        grid on
        set(gca, 'YDir', 'reverse');
        xlabel('Foam Density')
        %set(gca,'YTick',[]);
        %ylabel('Depth, ft')
        AX4 = subplot(1, 4, 4, 'Parent', handles.uipanel88);     
        hold all
        plot(VECTOR(:,7),VECTOR(:,1), 'DisplayName', [num2str(round(Ql)) ' gal/min'], 'LineStyle', a)
        grid on
        set(gca, 'YDir', 'reverse');
        xlabel('Velocity, ft/sec')
        %set(gca,'YTick',[]);
        %ylabel('Depth, ft')
        
    case 2
        AX1 = subplot(2, 1, 1) %, 'Parent', handles.uipanel88);
        hold all
        plot(Psv, BHP, 'DisplayName', [ num2str((Ql)) ' gal/min'])
        grid on
        title('Back-Pressure Envelope')
        xlabel('Back-Pressure, psi')
        ylabel('BHP, psi')
        AX2 = subplot(2, 1, 2) %, 'Parent', handles.uipanel88);
        hold all
        plot(Psv, QVbtm, 'DisplayName', [ num2str((Ql)) ' gal/min'])
        grid on
        xlabel('Back-Pressure, psi')
        ylabel('Gas Quality')
    case 3
        AX1 = subplot(1, 1, 1, 'Parent', handles.uipanel88);
        hold all
        plot(qG_SC, BHP, 'DisplayName', [ num2str((Ql)) ' gal/min'])
        Qmaxv = str2double(get(handles.editF4, 'String'))/100;
        maxvalx = interp1(QVtop,qG_SC,Qmaxv);
        maxvaly = interp1(qG_SC,BHP,maxvalx);
        plot(maxvalx, maxvaly, 'o', 'DisplayName' , ['Max Gas Quality for ', num2str((Ql))])
        Qminv = 0.50;
        minvalx = interp1(QVbtm,qG_SC,Qminv);
        minvaly = interp1(qG_SC,BHP,minvalx);
        plot(minvalx, minvaly, 'o', 'DisplayName' , ['Min Gas Quality for ', num2str((Ql))])
        grid on
        title('UBD Envelope')
        xlabel('Gas Flow Rate, scfpm')
        ylabel('BHP, psi')
        %AX2 = subplot(2, 1, 2, 'Parent', handles.uipanel88);
        %hold all
        %plot(Psv, QV)
        %grid on
        %xlabel('Back-Pressure, psi')
        %ylabel('Gas Quality')
    case 4
        AX1 = subplot(3, 1, 1:2) %, 'Parent', handles.uipanel88);
        hold all
        plot(qG_SC, QVbtm, 'DisplayName', ['Bottomhole @ ' num2str(round(Ql)) ' gal/min'])
        plot(qG_SC, QVtop, 'DisplayName', ['Surface @ ' num2str(round(Ql)) ' gal/min'])
        grid on
        title('Gas Qualities')
        xlabel('Gas Flow Rate, scfpm')
        ylabel('Gas Quality')
        AX2 = subplot(3, 1, 3)  %, 'Parent', handles.uipanel88);
        hold all
        plot(qG_SC, GLR, 'DisplayName', ['GLR @ ' num2str(round(Ql)) ' gal/min'])
        grid on
        xlabel('Gas Flow Rate, scfpm')
        ylabel('GLR, scf/stb')
    case 5
        AX1 = subplot(1, 1, 1, 'Parent', handles.uipanel88);
        hold all
        plot(qG_SC, BHP, 'DisplayName', ['Bottomhole Pressure @ ' num2str(round(Ql)) ' gal/min'])
        plot(qG_SC, Phyd, 'DisplayName', ['Hydrostatic Pressure @ ' num2str(round(Ql)) ' gal/min'])
        plot(qG_SC, Pfric, 'DisplayName', ['Frictional Pressure @ ' num2str(round(Ql)) ' gal/min'])
        grid on
        title('Pressure Contributions')
        xlabel('Gas Flow Rate, scfpm')
        ylabel('Pressure, psi')
        
        
        
        
end
drawnow
%end
end

if TYPE == 3
    pr = str2double(get(handles.edit104,'String'));
    hy = graph2d.constantline(pr,'DisplayName','Reservoir Pressure','LineStyle',':','LineWidth',2,'Color',[1 0 0]);
    changedependvar(hy,'y');
end


%end
    % Col1  -   Interval Number
    % Col2  -   Measured Depth In, ft
    % Col3  -   Measured Depth Out, ft
    % Col4  -   Length of Interval, ft
    % Col5  -   True Vertical Depth In, ft
    % Col6  -   True Vertical Depth Out, ft
    % Col7  -   Detpth Change, ft
    % Col8  -   Average Vertical Depth, ft
    % Col9  -   Average Temperature, F
    % Col10 -   Outer Diameter Annulus (Hole Size), ft
    % Col11 -   Inner Diameter Annulus (Drill Pipe OD), ft
    % Col12 -   Annular Capacity, sqft
    % Col13 -   Inclination, degrees
    % Col14 -   Guessed Pressure Change, psi
    % Col15 -   Inflow Pressure, psi
    % Col16 -   Outflow Pressure, psi
    % Col17 -   Average Pressure, psi
    % Col18 -   Pressure Gradient, psi
    % Col19 -   Pressure Change, psi
    % Col20 -   Iterations on interval

