clear all; close all; clc;
load simdata
hold all

plot(Poettmann, Depth,  'Color', [0 0 0], 'Marker', '*', 'MarkerSize', 2, 'LineStyle', '-', 'DisplayName', 'Poettmann & Carpenter')
plot(SimplPoett, Depth, 'Color', [0 0 0], 'Marker', '.', 'MarkerSize', 2, 'LineStyle', ':', 'DisplayName', 'Poettmann & Carpenter (simplified)')
plot(Brown, Depth,      'Color', [1 0 0], 'Marker', '*', 'MarkerSize', 2, 'LineStyle', '-', 'DisplayName', 'Fancher & Brown')
plot(Baxendall, Depth,  'Color', [1 0 0], 'Marker', '.', 'MarkerSize', 2, 'LineStyle', ':', 'DisplayName', 'Baxendell & Thomas')
plot(Hagedorn, Depth,   'Color', [0 1 0], 'Marker', '*', 'MarkerSize', 2, 'LineStyle', '-', 'DisplayName', 'Hagedorn & Brown')
plot(Gray, Depth,       'Color', [0 1 0], 'Marker', '.', 'MarkerSize', 2, 'LineStyle', ':', 'DisplayName', 'Gray')
plot(Beggs, Depth,      'Color', [0 0 1], 'Marker', '*', 'MarkerSize', 2, 'LineStyle', '-', 'DisplayName', 'Beggs & Brill')
plot(Dun, Depth,        'Color', [0 0 1], 'Marker', '.', 'MarkerSize', 2, 'LineStyle', ':', 'DisplayName', 'Dun & Ros')

set(gca,'YDir','reverse')
title('Annular Pressure Profiles for Different Correlations')
xlabel('Pressure, psi')
ylabel('Measured Depth, ft')
grid on


RR(1,1) = median(100*(SimplPoett./Poettmann-1));
RR(1,2) = mean(100*(SimplPoett./Poettmann-1));
RR(1,3) = max(100*(SimplPoett./Poettmann-1));
RR(1,4) = min(100*(SimplPoett./Poettmann-1));

RR(2,1) = median(100*(Brown./Poettmann-1));
RR(2,2) = mean(100*(Brown./Poettmann-1));
RR(2,3) = max(100*(Brown./Poettmann-1));
RR(2,4) = min(100*(Brown./Poettmann-1));

RR(3,1) = median(100*(Baxendall./Poettmann-1));
RR(3,2) = mean(100*(Baxendall./Poettmann-1));
RR(3,3) = max(100*(Baxendall./Poettmann-1));
RR(3,4) = min(100*(Baxendall./Poettmann-1));

RR(4,1) = median(100*(Hagedorn./Poettmann-1));
RR(4,2) = mean(100*(Hagedorn./Poettmann-1));
RR(4,3) = max(100*(Hagedorn./Poettmann-1));
RR(4,4) = min(100*(Hagedorn./Poettmann-1));

RR(5,1) = median(100*(Gray./Poettmann-1));
RR(5,2) = mean(100*(Gray./Poettmann-1));
RR(5,3) = max(100*(Gray./Poettmann-1));
RR(5,4) = min(100*(Gray./Poettmann-1));

RR(6,1) = median(100*(Beggs./Poettmann-1));
RR(6,2) = mean(100*(Beggs./Poettmann-1));
RR(6,3) = max(100*(Beggs./Poettmann-1));
RR(6,4) = min(100*(Beggs./Poettmann-1));

RR(7,1) = median(100*(Dun./Poettmann-1));
RR(7,2) = mean(100*(Dun./Poettmann-1));
RR(7,3) = max(100*(Dun./Poettmann-1));
RR(7,4) = min(100*(Dun./Poettmann-1));
