clear all; close all; clc;

i = 0;
yGv = 0.57:0.01:1.68;

for yG = yGv
    i = i + 1;
    [T_pc(i), P_pc(i)] = sutton(yG);
end

subplot(1,2,1)

plot(yGv,T_pc,'DisplayName', 'Sutton')
grid on
hold all
xlabel('Gas Gravity, s.g.')
ylabel('T_p_c, Rankine')
title('Pseudo Critical Temperature, Suttons Correlation')

GAS = {'AIR' 'NH3' 'CH4' 'N2' 'O2' 'C3H8' 'SO2'};

for i = 1:7
    GASTYPE = char(cell2mat(GAS(i)));
    [Mg, yG, T_pc, P_pc] = gasprop(GASTYPE);
    plot(yG,T_pc,'*','DisplayName', GASTYPE)
end
 
legend('show')

hold off

clear all;

i = 0;
yGv = 0.57:0.01:1.68;

for yG = yGv
    i = i + 1;
    [T_pc(i), P_pc(i)] = sutton(yG);
end

subplot(1,2,2)

plot(yGv,P_pc,'DisplayName', 'Sutton')
grid on
hold all
xlabel('Gas Gravity, s.g.')
ylabel('P_p_c, psi')
title('Pseudo Critical Pressure, Suttons Correlation')

GAS = {'AIR' 'NH3' 'CH4' 'N2' 'O2' 'C3H8' 'SO2'};

for i = 1:7
    GASTYPE = char(cell2mat(GAS(i)));
    [Mg, yG, T_pc, P_pc] = gasprop(GASTYPE);
    plot(yG,P_pc,'*','DisplayName', GASTYPE)
end
 
legend('show')